int POP_COLS = 6;
int POP_ROWS = 5;
int OFFSET = 1;
int POP_SIZE = POP_COLS * POP_ROWS;
int GRID_SIZE = int(pow(2, Individual.SIZE_GENE_LENGTH+1) - 1);

int FITNESS_EXPONENT = 2; // raise fitness to this to steepen it

int generation = 0;
Population pop;

void settings() {
  size(POP_COLS*GRID_SIZE + (POP_COLS-1)*OFFSET,
       POP_ROWS*GRID_SIZE + (POP_ROWS-1)*OFFSET);
}//settings
void setup() {
  pop = new Population(POP_SIZE);
  makePopulation();
}//setup

void draw() {
  background(255);
  pop.drawPopGrid(POP_COLS, POP_ROWS, GRID_SIZE, OFFSET, true);
  pop.drawHighlight(POP_COLS, POP_ROWS, GRID_SIZE, OFFSET, 0, color(0));
  pop.drawHighlight(POP_COLS, POP_ROWS, GRID_SIZE, OFFSET, pop.getBestIndex(), color(255,150,50));
  drawGrid();
}//draw

void keyPressed() {
  if (key == 'p') {
    makePopulation();
  }
   if (key == 'm') {
     runMating();
  }

}//keyPressed


void makePopulation() {
  generation = 0;
  pop.randomPop();
  pop.setFitness(pop.get(0));
}//makePopulation()


void runMating() {
  generation += 1;
  pop = pop.matingSeason();
  pop.setFitness(pop.get(0));
  println("Generation ", generation, 
          "avg fitness:", nf(pop.getAverageFitness(),0,3) , 
          " best fitness:", nf(pop.getBestFitness(),0,3));
}


void drawGrid() {
  stroke(0);
  strokeWeight(1);
  for (int i=1; i < POP_COLS; i++) {
    int x = i * (GRID_SIZE + OFFSET);
    line(x, 0, x, height-1);
  }//row dividers

  for (int i=1; i < POP_ROWS; i++) {
    int y = i * (GRID_SIZE + OFFSET);
    line(0, y, width-1, y);
  }//column dividers
}//drawGrid
